<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\Sm00012000MedicaoFaturamentoService;

class Sm00012000MedidasVariaveisMedicaoFaturamentoController extends SMCrud {
    
    protected $dataSourceName = "fct_medvarmedicaofatura";
    
    protected $medicaoService;
    
    public function __construct($crudService, $environment, Sm00012000MedicaoFaturamentoService $medicaoService) {
        parent::__construct($crudService, $environment);
        $this->medicaoService = $medicaoService;
    }
    
    public function find(Request\Filter $request, Response $response) {
        try {
            $newResponse = new Response();
            
            $this->dataSourceName = "fct_medvarmedicaofatura_tela_medicao_join_com_medida";
            $request->setParameter(self::DATABASE_NAME, $this->dataSourceName);
            parent::find($request, $newResponse);
            $erro = $newResponse->getError();
            if ($erro) {
                throw new \Exception($erro->getMessage(), $erro->getErrorCode());
            }
            
            $dadosComMedida = $newResponse->getDataSets()[0]->getRows();
            
            $newResponse = new Response();
            
            $this->dataSourceName = "fct_medvarmedicaofatura_tela_medicao_join_sem_medida";
            $request->setParameter(self::DATABASE_NAME, $this->dataSourceName);
            parent::find($request, $newResponse);
            $erro = $newResponse->getError();
            if ($erro) {
                throw new \Exception($erro->getMessage(), $erro->getErrorCode());
            }
            
            $dadosSemMedida = $newResponse->getDataSets()[0]->getRows();
            
            $dataset = $this->medicaoService->mergeItensParaMedicao($dadosComMedida, $dadosSemMedida);
            $response->setDataSets(array(new DataSet("fct_medvarmedicaofatura_tela_medicao", $dataset)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}

?>