<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00034000MaximoCarenciaPropostaFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
     /**
     * A função "validaCarenciaOperador" verifica se já existe 
     * uma carencia cadastrada para o operador indicado.
     */
     
    public function validaCarenciaOperador($params){
        
        $queryValidaCarenciaOperProp = "SELECT COUNT(*) AS VALIDAOPER
                                      FROM FCT_CARENCIAOPER
                                     WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                                       AND NRORG = :NRORG";

        $std = $this->connection->prepare($queryValidaCarenciaOperProp);
        $std->execute($params);
        $returnValidaCarenciaOperProp = $std->fetchAll();
        return $returnValidaCarenciaOperProp;
    }
    
    /**
     * A função "validaCarenciaOperador" verifica se já existe 
     * uma carencia cadastrada para o operador indicado.
     */
     
    public function validaCarenciaOperOuPerf($params){
        $queryValidaCarenciaOperPerf = "SELECT NRDIAMAXIMO, TIPO 
                                        FROM (SELECT NRDAISMAXCARENCIA AS NRDIAMAXIMO, 
                                                     1 AS TIPO
                                                FROM FCT_CARENCIAOPER
                                                    WHERE NRPARCNEGOCIO IN 
                                                        (SELECT NRPARCNEGOCIO
                                                         FROM OPERADOR
                                                         WHERE CDOPERADOR = :CDOPERADOR
                                                            AND NRORG     = :NRORG)
                                                UNION ALL
                                                SELECT * 
                                                FROM (SELECT MAX(NRDAISMAXCARENCIA) AS NRDIAMAXIMO, 
                                                        2 AS TIPO
                                                        FROM FCT_CARENCIAPERFIL
                                                        WHERE NRPERFILACESSO IN (SELECT NRPERFILACESSO
                                                                                 FROM PERFACESSPARC
                                                                                 WHERE NRPARCNEGOCIO IN 
                                                                                    (SELECT NRPARCNEGOCIO
                                                                                     FROM OPERADOR
                                                                                     WHERE CDOPERADOR = :CDOPERADOR
                                                                                        AND NRORG     = :NRORG))) 
                                        WHERE NRDIAMAXIMO IS NOT NULL)";

        $std = $this->connection->prepare($queryValidaCarenciaOperPerf);
        $std->execute($params);
        $returnValidaCarenciaOperPerf = $std->fetchAll();
        return $returnValidaCarenciaOperPerf;
    }

}
?>