<?php
namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\SmPercentualDescontoOperadorFactory;
use Teknisa\Libs\Util\Environment;

class SmPercentualDescontoOperadorService
{
    
    protected $percDescOperadorFactory;
    protected $Environment;
    
    public function __construct (SmPercentualDescontoOperadorFactory $percDescOperadorFactory, Environment $Environment){
        
        $this->percDescOperadorFactory  = $percDescOperadorFactory;
        $this->Environment  = $Environment;

    }
    
    /**
     * A função "validaPercentDescontoOPer" verifica se já existe 
     * um percentual de desconto cadastrado para o operador indicado.
     */
    public function validaPercentDescontoOper($parcOperador){
    
        $paramsValidaPercDescOper = array(
            "NRPARCNEGOCIO"  => $parcOperador,
            "NRORG"          => $this->Environment->getNrOrg()
        );
        
        $returnValidaPercDescOper = $this->percDescOperadorFactory->validaPercentDescontoOper($paramsValidaPercDescOper);
        
        return $returnValidaPercDescOper[0]["VALIDAOPER"] != 0;
        
    }

}
?>