<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctConversaoCliente {
    
    const NOME = "FCT_CONVERSAO_CLIENTE";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrseqcontrato
     * @param string  $operador
     * @param integer $nrorg
     */
    public function executar($nrorg, $operador, $nrparcnegocio) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRPARCNEGOCIO",  Param::PARAM_INPUT,  $nrparcnegocio,   Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_OPERADOR",       Param::PARAM_INPUT,  $operador,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRORG",          Param::PARAM_INPUT,  $nrorg,           Param::PARAM_TYPE_INT));
        
        $procedure->execute();
    }
    
}

?>

